package com.study;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Scanner;
import java.util.Set;

import org.kie.api.KieServices;
import org.kie.api.builder.KieRepository;
import org.kie.api.builder.KieScanner;
import org.kie.api.builder.ReleaseId;
import org.kie.api.runtime.KieContainer;
import org.kie.api.runtime.KieSession;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * This is a sample class to launch a rule.
 */
public class DroolsTest {

	private static final Logger log = LoggerFactory.getLogger(DroolsTest.class);

    public static final void main(String[] args) {

    	log.debug("Begin execution");

    	Scanner scanner = new Scanner(System.in);
        try {
            // load up the knowledge base
	        KieServices ks = KieServices.Factory.get();
    	    //KieContainer kContainer = ks.getKieClasspathContainer();

	        ReleaseId releaseId = ks.newReleaseId( "com.study", "drools_sample", "0.0.1-SNAPSHOT" );
	        KieContainer kContainer = ks.newKieContainer( releaseId );
System.out.println("Release: " + kContainer.getReleaseId());

        	KieSession kSession = null; //kContainer.newKieSession("ksession-rules_jar");
        	KieScanner kScanner = ks.newKieScanner( kContainer );

        	boolean repeat = true;

            // go !
        	while(repeat)
        	{
        		kSession = kContainer.newKieSession("ksession-rules_jar");
        		Message message = new Message();
        		message.setMessage("Hello World");
        		message.setStatus(Message.HELLO);
        		DynamicFactType dft = new DynamicFactType();
        		kSession.insert(message);
        		kSession.insert(dft);
        		//System.out.println("DynamicFactType is: " + dft);
        		kSession.fireAllRules();
        		kSession.dispose();

        		String inp = scanner.nextLine();
        		if(inp.length() > 0)
        			repeat = false;
        		else
        		{
        			kScanner.scanNow();
        		}
        	}
        } catch (Throwable t) {
            t.printStackTrace();
        }
        scanner.close();
    }

    public static class Message {

        public static final int HELLO = 0;
        public static final int GOODBYE = 1;

        private String message;

        private int status;

        public String getMessage() {
            return this.message;
        }

        public void setMessage(String message) {
            this.message = message;
        }

        public int getStatus() {
            return this.status;
        }

        public void setStatus(int status) {
            this.status = status;
        }

    }

}
